#ifndef CYGONCE_HAL_PLATFORM_INC
#define CYGONCE_HAL_PLATFORM_INC
##=============================================================================
##
##	platform.inc
##
##	JMR-TX3904 board assembler header file
##
##=============================================================================
#####ECOSGPLCOPYRIGHTBEGIN####
## -------------------------------------------
## This file is part of eCos, the Embedded Configurable Operating System.
## Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
##
## eCos is free software; you can redistribute it and/or modify it under
## the terms of the GNU General Public License as published by the Free
## Software Foundation; either version 2 or (at your option) any later version.
##
## eCos is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without even the implied warranty of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
## for more details.
##
## You should have received a copy of the GNU General Public License along
## with eCos; if not, write to the Free Software Foundation, Inc.,
## 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
##
## As a special exception, if other files instantiate templates or use macros
## or inline functions from this file, or you compile this file and link it
## with other works to produce a work based on this file, this file does not
## by itself cause the resulting work to be covered by the GNU General Public
## License. However the source code for this file must still be made available
## in accordance with section (3) of the GNU General Public License.
##
## This exception does not invalidate any other reasons why a work based on
## this file might be covered by the GNU General Public License.
##
## Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
## at http://sources.redhat.com/ecos/ecos-license/
## -------------------------------------------
#####ECOSGPLCOPYRIGHTEND####
##=============================================================================
#######DESCRIPTIONBEGIN####
##
## Author(s): 	nickg
## Contributors:	nickg
## Date:	1999-04-06
## Purpose:	JMR-TX3904 board definitions.
## Description:	This file contains various definitions and macros that are
##              useful for writing assembly code for the JMR-TX3904 board.
## Usage:
##		#include <cyg/hal/platform.inc>
##		...
##		
##
######DESCRIPTIONEND####
##
##=============================================================================

#include <cyg/hal/mips.inc>

#include <cyg/hal/hal_arch.h>
#include <cyg/hal/plf_io.h>

#------------------------------------------------------------------------------
# Interrupt decode macros

# Only INTN[0] is connected on the Malta board. We need to access the
# interrupt controller to get the actual vector number.

#ifndef CYGPKG_HAL_MIPS_INTC_DEFINED

#ifndef CYGPKG_HAL_MIPS_INTC_INIT_DEFINED

	.macro	hal_intc_init
	# mask all interrupt source on interrupt controller
	la	v0,   IC_BASE 
	la	t0,   0xfe98d000
	la	t1,   -1
	sw	zero, (ISR1*4)(v0)
	sw	t0,   (ISR2*4)(v0)	/* t0=7,t1=6,uart=5,wd=4,mac=3 */
	sw	t1,   (ISTS*4)(v0)	/* clear status */
	sw	t1,   (IMSK*4)(v0)	/* clear status */
	
	#unmusk all IM bits
	mfc0	v0,status
	nop
	ori	v0,v0, 0xfc00
	mtc0	v0,status
	nop
	.endm

#define CYGPKG_HAL_MIPS_INTC_INIT_DEFINED

#endif

#ifndef CYGPKG_HAL_MIPS_INTC_DECODE_DEFINED
	.macro	hal_intc_decode vnum
	mfc0	v1,status		# get status register (interrupt mask)
	mfc0	v0,cause		# get cause register
	andi	v1, v1, 0xff00	# delay slot
	and		v0, v0, v1		# apply interrupt mask
	li		\vnum, 8
	li		t1, 0x8000
	li		t2, 0x0200
2:
	subu	\vnum, 1
	and		v1, v0, t1
	bnez	v1, 4f
	srl		t1, t1, 1
	bne		t1, t2, 2b
4:
	nop
	.endm

	.macro	hal_intc_decode_data
hal_intc_translation_table:	
	.endm
	
#define CYGPKG_HAL_MIPS_INTC_DECODE_DEFINED	

#endif

#ifndef CYGPKG_HAL_MIPS_INTC_TRANSLATE_DEFINED
	.macro	hal_intc_translate inum,vnum
	move	\vnum,\inum			# Vector == interrupt number
	.endm
#define CYGPKG_HAL_MIPS_INTC_TRANSLATE_DEFINED
#endif

#define CYGPKG_HAL_MIPS_INTC_DEFINED
#endif

#define CYG_HAL_MIPS_ISR_TABLES_DEFINED

#------------------------------------------------------------------------------
#endif // ifndef CYGONCE_HAL_PLATFORM_INC
# end of platform.inc
